program gf2cgi
!! GeoFOld CGI server program 2
!! This program is called by the FORM generated by the
!! first server program, gf1cgi2.f90
!!
!! C.Bystroff Thu Nov 20 21:27:50 EST 2008
!!----------------------------------------
  use gfcgi
  implicit none
  character(len=2000) :: aline,paramline
  character(len=200) :: email, jobfile,urlname,command,pdbdir,codeline
  character(len=200) :: paramfile, lname,tmpdir,pidline,waitimage
  character(len=200) :: emailaddress
  character(len=80) :: code
  character(len=24) :: chains, pdbchains
  character(len=50) :: outdir, jobdir
  character(len=3) :: atchar,slashchar,percentchar,pluschar
  integer :: pid, ios, i,j, punit=23, bunit
  logical :: debug=.true.
  !!---------
  waitimage = "http://www.bioinfo.rpi.edu/bystrc/pub/mpeg/peptide.gif"
  pdbchains = " "
  codeline = " "
  urlname = " "
  email = " "
  lname = " "
  pidline = " "
  emailaddress = " "
  atchar = "@"
  pdbdir = "/ext1/bystrc/server/data/pdb/"
  tmpdir = "/ext1/bystrc/server/geofold/tmp/"
  !! call getenv("PDB",pdbdir)
  outdir="output/"
  jobdir="jobs/"
  !! uses method="POST" 
  !!---------------------------- get form data from stdin, all one line
  read(*,*) aline
  if (debug) write(0,'(a)') trim(aline)  !! ---- goes to error_log
  !!---------------------------- parse email
  call gfcgi_parseit(aline,"email_address",emailaddress)
  if (debug) write(0,'(a)') "email_address="//trim(emailaddress)
  !!---------------------------- list of special characters passed as hidden from RUNGEOFOLD.csh
  !! '<INPUT type="hidden" name="slash" value="/">'
  !! '<INPUT type="hidden" name="space" value=" ">'
  !! '<INPUT type="hidden" name="plus" value="+">'
  !! '<INPUT type="hidden" name="at" value="@">'
  !! '<INPUT type="hidden" name="percent" value="%">'
  !!---------------------------- parse special characters from hidden input
  call gfcgi_parseit(aline,"at",atchar)
  call gfcgi_parseit(aline,"slash",slashchar)
  call gfcgi_parseit(aline,"percent",percentchar)
  call gfcgi_parseit(aline,"plus",pluschar)
  !!---------------------------- extract username
  i = index(emailaddress,"@")
  if (i==0) then
    i = index(emailaddress,trim(atchar))
  endif
  email = emailaddress(1:i-1)
  !!---------------------------- parse PID
  call gfcgi_parseit(aline,"pid",pidline)
  if (pidline==" ") then
    pid = getpid()
  else
    read(pidline,*,iostat=ios) pid
    if (ios/=0) stop 'gf2cgi:: error parsing pidline.'
  endif
  !!---------------------------- parse pdb code
  codeline = " "
  call gfcgi_parseit(aline,"pdbid",codeline)
  if (debug) write(0,'(a)') "pdbid="//trim(codeline)
  code = trim(codeline)
  codeline = " "
  !!---------------------------- parse biolunit ("biolunit" or "select")
  call gfcgi_parseit(aline,"unit",codeline)
  if (debug) write(0,'(a)') "unit="//trim(codeline)
  read(codeline,*,iostat=ios) bunit
  if (ios/=0) stop 'gf2cgi.f90:: ERROR parsing field "unit"'
  codeline = " "
  !!---------------------------- parse chain IDs
  call gfcgi_parseit(aline,"chains",codeline)
  chains = trim(codeline)
  if (chains==" ") chains = "_"
  if (debug) write(0,'(a)') "chains="//trim(chains)
  !!------------------------- create file names
  write(urlname,'(a,a,i5.5,".html")') trim(outdir),trim(email),pid
  if (debug) write(0,'(a)') "urlname="//trim(urlname)
  write(paramfile,'(a,a,i5.5,".par")') trim(tmpdir),trim(email),pid
  if (debug) write(0,'(a)') "paramfile="//trim(paramfile)
  !!--------------------------- Write HTML output
  write(*,'(a,//)') 'Content-type: text/html'
  write(*,'(a)') "<html>"
  write(*,'(a)') "<head>"
  write(*,'(a,a,a)') '<meta http-equiv="refresh" content="1;url=',trim(urlname),'">'
  write(*,'(a)') "</head>"
  write(*,'(a)') "<body>"
  write(*,'(a)') "<h4>Please wait...</h4><br>"
  !!---------------------- replace special characters in parameters data
  call gfcgi_parseit(aline,"params",paramline)
  call gfcgi_replace(paramline,"+"," ")
  call gfcgi_replace(paramline,atchar,"@")
  call gfcgi_replace(paramline,"%0A","")
  call gfcgi_replace(paramline,pluschar,"+")
  call gfcgi_replace(paramline,slashchar,"/")
  call gfcgi_replace(paramline,percentchar,"%")
  call gfcgi_replacefield(str=paramline,srch="%0D",tag="CHAIN",rplc="CHAIN "//trim(chains))
  if (debug) write(0,'(a)') "paramline="//trim(paramline)
  call gfcgi_parseit(aline,"lname",lname)
  if (debug) write(0,'(a)') "lname="//trim(lname)
  !!----------------------- write parameters file
  open(punit,file=paramfile,status='replace',form='formatted',iostat=ios)
  if (ios/=0) then
    write(*,'(a)') '<h1>BUG cant write paramfile.</h1> Permissions?'
    stop
  endif
  call gfcgi_split(paramline,"%0D",punit,tag="")
  close(punit)
  write(*,'(a)') "</body>"
  write(*,'(a)') "</html>"
  !!---------------------- Write web page to file refreshed in stdout url -------------
   if (debug) write(0,'(a)') "Writing to output URL="//trim(urlname)
   open(9,file=trim(urlname),status='replace',action='readwrite',form='formatted',iostat=ios)
   if (ios/=0) stop '<html><body>Error opening file for writing. Permissions? 9</body></html>'
   write(urlname,'(a,i5.5,".html")') trim(email),pid
   if (debug) write(0,'(a)') "refresh to urlname="//trim(urlname)
   write(9,'(a,//)') '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">'
   write(9,'(a)') "<html>"
   write(9,'(a)') "<head>"
   write(9,'(a,a,a)') "<title>",trim(urlname),"</title>"
   write(9,'(a,a,a)') '<meta http-equiv="refresh" content="4;url=',trim(urlname),'">'
   write(9,'(a)') "</head>"
   write(9,'(a)') "<body>"
   write(9,'(a)') "Your GeoFold job has been submitted"
   write(9,'(a,a,a,a)') " for ",trim(code)," chains ",trim(chains)
   write(9,'(a,a,a)') '<p>BOOKMARK THIS PAGE:<A HREF="',trim(urlname),'">',trim(urlname),'</A><br>'
   write(9,'(a)') "<p> Please wait, you will be forwarded a progress page"
   write(9,'(a)') " and then a results page containing <br>"
   write(9,'(a)') "(1) an unfolding pathway in the form of a pathway tree, with the high-traffic intermediates highlighted <br>"
   write(9,'(a)') "(2) a contact map expressing the structure of the majority folding intermediates. <br>"
   write(9,'(a)') "(3) simulated folding rates in virtual  denaturant, extrapolated to pure water. <br>"
   write(9,'(a)') '<p> <img src="'//trim(waitimage)//'"><br>'
   write(9,'(a)') "</body>"
   write(9,'(a)') "</html>"
   close(9)
  !!--------------------------- Write the job file
  write(jobfile,'(a,a,i5.5,".job")') trim(jobdir),trim(email),pid
  if (debug) write(0,'(a)') "jobfile="//trim(jobfile)
  open(11,file=jobfile,status='replace',form='formatted',iostat=ios)
  if (ios/=0) stop '<html><body>Error opening jobfile for writing. Permissions? 1</body></html>'
  write(11,'(a,i4,a)') trim(code)//" "//trim(chains),bunit," "//trim(lname)
  close(11)
  !!--------------------------- deprotect the jobfile (is there a way to do this in fortran?)
  command = "chmod 0777 "//trim(outdir)//trim(urlname)
  call system(command)
  command = "chmod 0777 "//trim(jobfile)
  call system(command)
  command = "chmod 0777 "//trim(paramfile)
  call system(command)
  !!----------------------------------------------------
end program gf2cgi
