program gfcgi
!! GeoFOld CGI server
!! C.Bystroff Fri Jul 25 08:06:35 EDT 2008
  implicit none
  character(len=72) :: aline, codeline
  character(len=200) :: email, jobfile, urlname, command, pdbdir
  character(len=4) :: code
  character(len=24) :: chains, pdbchains
  character(len=50) :: outdir, jobdir
  integer :: pid, ios, i,j
  !!---------
  pdbchains = " "
  pdbdir = "/ext1/bystrc/server/data/pdb/"
  !! call getenv("PDB",pdbdir)
  outdir="output/"
  jobdir="jobs/"
  !! uses method="POST" 
  read(*,*) aline
  call parseit(aline,"email_address",email)
  j = index(email,'%40')
  if (j==0) call errormsg("email_address",email)
  email = email(1:j-1)
  call parseit(aline,"pdbid",codeline)
  if (len(trim(codeline))/=4) call errormsg("pdbid",codeline)
  code = trim(codeline)
  if (pdbdir/=" ") then
    call findpdbfile(code,pdbdir,pdbchains)
  endif
  call parseit(aline,"chains",codeline)
  !! if (len(trim(codeline))/=4) call errormsg("chains",codeline)
  chains = trim(codeline)
  pid = getpid()
  write(urlname,'(a,a,i9.9,".html")') trim(outdir),trim(email),pid
  !! Write HTML output
  write(*,'(a,//)') 'Content-type: text/html'
  write(*,'(a)') "<html>"
  write(*,'(a)') "<head>"
  write(*,'(a,a,a)') '<meta http-equiv="refresh" content="3;url=',trim(urlname),'">'
  write(*,'(a)') "</head>"
  write(*,'(a)') "<body>"
  write(*,'(a)') "<h4>Please wait...</h4><br>"
  !! diagnostic
  !! write(*,'(a)') trim(aline)
  write(*,'("email=",a,"<br>")') trim(email)
  write(*,'("code=",a,"<br>")') trim(code)
  if (pdbdir==" ") then
    write(*,'("Local PDB directory is missing<br>")') 
  elseif (pdbchains==" ") then
    write(*,'("File not found locally<br>")') 
  else
    write(*,'("PDB file found, chains available:",a,"<br>")') trim(pdbchains)
  endif
  
  write(*,'("chains=",a,"<br>")') trim(chains)
  write(*,'("pid=",i9,"<br>")') pid
  write(*,'(a)') "</body>"
  write(*,'(a)') "</html>"
  !! Write web page
   open(9,file=trim(urlname),status='replace',action='readwrite',form='formatted',iostat=ios)
   if (ios/=0) stop '<html><body>Error opening file for writing. Permissions? 9</body></html>'
  write(urlname,'(a,i9.9,".html")') trim(email),pid
   write(9,'(a,//)') '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">'
   write(9,'(a)') "<html>"
   write(9,'(a)') "<head>"
   write(9,'(a,a,a)') "<title>",trim(urlname),"</title>"
   write(9,'(a,a,a)') '<meta http-equiv="refresh" content="10;url=',trim(urlname),'">'
   write(9,'(a)') "</head>"
   write(9,'(a)') "<body>"
   write(9,'(a)') "Your GeoFold job has been submitted<br>"
   write(9,'(a,a,a)') 'Check this page to see the results:<A HREF="',trim(urlname),'">',trim(urlname),'</A><br>'
   write(9,'(a)') "(1) an unfolding pathway in the form of a pathway tree, with the high-traffic intermediates highlighted <br>"
   write(9,'(a)') "(2) a contact map expressing the structure of the majority folding intermediates. <br>"
   write(9,'(a)') "(2) simulated folding rates in urea, extrapolted to pure water. <br>"
   write(9,'(a)') "</body>"
   write(9,'(a)') "</html>"
   close(9)
  !! Write the job file
  write(jobfile,'(a,a,i9.9,".job")') trim(jobdir),trim(email),pid
  open(11,file=jobfile,status='replace',form='formatted',iostat=ios)
  ! if (ios/=0) stop '<html><body>Error opening file for writing. Permissions? 1</body></html>'
  write(11,'(a)') code
  close(11)
  command = "chmod 0777 "//trim(outdir)//trim(urlname)
  call system(command)
  command = "chmod 0777 "//trim(jobfile)
  call system(command)
CONTAINS
  !---------------------------------------------
  subroutine parseit(aline,atag,result)
    character(len=*),intent(in) :: aline, atag
    character(len=*),intent(out) :: result
    integer :: i,j,ich, k
    i = index(aline,atag)
    ! write(*,*) aline(1:i)
    j = i + len(atag)+1
    k = index(aline(j:),'&')
    result = aline(j:j+k-2)
    ! write(*,*) trim(result)
  end subroutine parseit
  !---------------------------------------------
  subroutine errormsg(atag,entry)
    character(len=*),intent(in) :: atag,entry
    write(*,'(a,//)') 'Content-type: text/html'
    write(*,'(a)') '<meta http-equiv="refresh" content="30;url=server.php">'
    write(*,'(a)') "<html>"
    write(*,'(a)') "<body>"
    write(*,'(a,a)') '<font color="#FF0000">ERROR! Please enter a valid </font>',trim(atag)
    write(*,'(a,a,a)') 'You entered "',trim(entry),'" </font>'
    write(*,'(a)') '<h2><A HREF="server.php">try again</A></h2>'
    write(*,'(a)') "</body>"
    write(*,'(a)') "</html>"
    stop
  end subroutine errormsg
  !---------------------------------------------
  subroutine findpdbfile(code,pdbdir,pdbchains)
    character(len=*),intent(in) :: pdbdir, code
    character(len=*),intent(out) :: pdbchains
    character(len=200) :: pdbfile, aline
    character :: chchar
    logical :: isthere
    integer :: ios, ich
    !!
    pdbfile = trim(pdbdir)//trim(code)//".pdb"
    inquire(file=pdbfile,exist=isthere)
    if (isthere) then
      open(11,file=pdbfile,status='old',form='formatted',iostat=ios)
      if (ios/=0) then
        write(*,'(a)') "File could not be opened.<br>"
      else
        ich = 0
        do 
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) exit
          if (aline(1:5)/="ATOM ") cycle
          chchar = aline(22:22)
          if (index(pdbchains,chchar)==0) then
            ich = ich + 1
            pdbchains(ich:ich) = chchar
          endif
        enddo
        !! write(*,'(i9,a)') ich," chains found.<br>"
      endif
    else
      pdbchains = " "
    endif
  end subroutine findpdbfile
  !---------------------------------------------
end program gfcgi
